/**
 * Copyright (c) 2009-2012, Netbout.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are PROHIBITED without prior written permission from
 * the author. This product may NOT be used anywhere and on any computer
 * except the server platform of netBout Inc. located at www.netbout.com.
 * Federal copyright law prohibits unauthorized reproduction by any means
 * and imposes fines up to $25,000 for violation. If you received
 * this code occasionally and without intent to use it, please report this
 * incident to the author by email.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
package com.netbout.notifiers.facebook;

import com.netbout.rest.BaseRs;
import com.netbout.rest.NbPage;
import com.restfb.DefaultFacebookClient;
import com.rexsl.page.PageBuilder;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.core.Response;

/**
 * Facebook canvas (the URL of it should be configured in facebook developers
 * panel).
 *
 * @author Yegor Bugayenko (yegor@netbout.com)
 * @version $Id$
 */
@Path("/canvas")
public final class CanvasRs extends BaseRs {

    /**
     * Facebook canvas.
     *
     * <p>FB sends {@code fb_source}, {@code ref}, {@code count}, and
     * {@code fb_bmpos}.
     *
     * @return The JAX-RS response
     * @see <a link="http://developers.facebook.com/docs/guides/canvas/">Graph API, Canvas</a>
     */
    @POST
    @Path("/")
    public Response canvas() {
        new Requests(
            new DefaultFacebookClient(new TokenBuilder().build()),
            this.identity().name().nss()
        ).clean("");
        return new PageBuilder()
            .build(NbPage.class)
            .init(this)
            .preserved()
            .status(Response.Status.SEE_OTHER)
            .location(this.base().build())
            .build();
    }

}
